﻿using System;
using System.Runtime.InteropServices;
using Inventor;

namespace InventorThumbnailAddin
{
    [ComVisible(true)]
    public class Automation
    {
        InventorServer m_server;

        public Automation(InventorServer server)
        {
            m_server = server;
        }

        public void Run(Document document)
        {
            string documentFolder = System.IO.Path.GetDirectoryName(document.FullFileName);
            string imageFilename = System.IO.Path.Combine(documentFolder, "thumbnail.bmp");
            if (document.DocumentType == DocumentTypeEnum.kPartDocumentObject)
            {
                Camera camera = m_server.TransientObjects.CreateCamera();
                camera.SceneObject = (document as PartDocument).ComponentDefinition;
                camera.ViewOrientationType = ViewOrientationTypeEnum.kIsoTopRightViewOrientation;
                camera.ApplyWithoutTransition();
                camera.SaveAsBitmap(imageFilename, 256, 256, Type.Missing, Type.Missing);
            }
        }

        public void RunWithArguments(Document document, NameValueMap args)
        {
            Run(document);
        }
    }
}