using System;
using System.Runtime.InteropServices;
using Inventor;

namespace InventorThumbnailAddin
{
    [GuidAttribute("f7bd603e-53d8-4acc-bb91-8fe341e8c5b1")]
    public class StandardAddInServer : Inventor.ApplicationAddInServer
    {
        private InventorServer m_server;
        private Automation m_automation;

        public StandardAddInServer()
        {
        }

        #region ApplicationAddInServer Members

        public void Activate(Inventor.ApplicationAddInSite addInSiteObject, bool firstTime)
        {
            m_server = addInSiteObject.InventorServer;
            m_automation = new Automation(m_server);
        }

        public void Deactivate()
        {
            Marshal.ReleaseComObject(m_server);
            m_server = null;

            GC.Collect();
            GC.WaitForPendingFinalizers();
        }

        public void ExecuteCommand(int commandID)
        {
        }

        public dynamic Automation
        {
            get
            {
                return m_automation;
            }
        }

        #endregion
    }
}
